/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.instruction.AddressingMode;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class R extends AddressingMode {
  public static final String NAME = "R";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          R.class,
          "R",
          LONG,
          new ParamDecls()
              .declareParam("i", INDEX),
          false,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public IAddressingMode create(Map<String, Data> args) {
      final Location i = getArgument("i", args);
      return new R(i);
    }
  }

  public static final IInfo INFO = new Info();

  private final Location i;

  public R(Location i) {
    this.i = i;
  }

  @Override
  public String syntax() {
    return String.format("%d", i.load().getRawData().intValue());
  }

  @Override
  public String image() {
    return String.format("%5b", i.load().getRawData().toBinString());
  }

  @Override
  public void action() {
    if (DataEngine.intValue(i.load()) == 0x0)
    {
        GPR.access(i.load()).store(DataEngine.coerce(WORD, DataEngine.valueOf(Type.INT(0x1), 0)));
    }
  }

  @Override
  public Location access() {
    return GPR.access(i.load());
  }
}
 